#include "bsp_wdt.h"
#include <stdio.h>
#include <string.h>
WDT_InitTypeDef WDT_InitStructure;
int reset_test = 0;
int rst_info = 0;
void wdt_test(void)
{
 	 uint32_t value;
	rst_info = W7500x_SYSCON->RSTINFO;
    // 0 : SYSRESETREQ
    // 1 : Watchdog reset
    // 2 : Processor LOCKUP reset
    
    if((rst_info & WDTRESETREQ_Msk) != 0) //Reset request is caused by WDT
    {
        WDT_IntClear();
				printf("Reset request is caused by WDT!\r\n");
        while(1);
    }
    else if((rst_info & SYSRESETREQ_Msk) != 0) //Reset request is caused by SYSTEM
    {
				printf("Reset request is caused by SYSTEM!\r\n"); 
				WDT_InitStructure.WDTLoad = 0xFF0000;
				WDT_InitStructure.WDTControl_RstEn = WDTControl_RstEnable;
				WDT_Init(&WDT_InitStructure);
				WDT_Start();
				printf("Watchdog Start!\r\n");
    } 
    while(1)
    { 
				value=WDT_GetWDTValue();
        printf("wdt=0x%x\r\n",value);
			  delay_ms(100);
        if(value< 0x7000)
        {
            printf("wdt=%d\r\n",value);
					  WDT_SetWDTLoad(0xFF0000);
            // LED red is toggled /
            if(GPIO_ReadOutputDataBit(GPIOC,GPIO_Pin_14) != (uint32_t)Bit_RESET)
                GPIO_ResetBits(GPIOC, GPIO_Pin_14);
            else
                GPIO_SetBits(GPIOC, GPIO_Pin_14);
        }
    }
}



