#ifndef _BSP_WDT_H_
#define _BSP_WDT_H_
#include "W7500x.h"
#include "time_delay.h"

/* Private typedef -----------------------------------------------------------*/
typedef struct
{
  __IO   uint32_t  REMAP;          /*!< Offset: 0x000 Remap Control Register (R/W) */
  __IO   uint32_t  PMUCTRL;        /*!< Offset: 0x004 PMU Control Register (R/W) */
  __IO   uint32_t  RESETOP;        /*!< Offset: 0x008 Reset Option Register  (R/W) */
  __IO   uint32_t  EMICTRL;        /*!< Offset: 0x00C EMI Control Register  (R/W) */
  __IO   uint32_t  RSTINFO;        /*!< Offset: 0x010 Reset Information Register (R/W) */
} W7500x_SYSCON_TypeDef;

/* Private define ------------------------------------------------------------*/
#define W7500x_SYSCON            ((W7500x_SYSCON_TypeDef *) W7500x_SYSCTRL_BASE)
#define W7500x_SYSCTRL_BASE      (0x4001F000)
#define SYSRESETREQ_Msk 0x1
#define WDTRESETREQ_Msk 0x2

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/


void wdt_test(void);

#endif
